module m_mxv

contains

  subroutine mxv(A, M, N, x, y)
    integer, intent(in) :: M, N
    double precision, dimension(M * N), intent(in) :: A
    double precision, dimension(N), intent(in) :: x
    double precision, dimension(M), intent(out) :: y
    
    integer :: i, j

    double precision :: tmp

!$omp parallel do shared(A, x, y, M, N) private(tmp, i, j)
    do i = 0, M - 1
       tmp = 0.0
       do j = 1, N
          tmp = tmp + A(i * N + j) * x(j)
       end do
       y(i) = tmp
    end do
!$omp end parallel do

  end subroutine mxv

end module m_mxv
